"""
Module of recursively defined functions.

In each of these functions, the recursive steps are
explicit in the specification.

Author: Walker M. White (wmw2)
Date: October 12, 2020
"""


def lucas(n,p,q):
    """
    Returns the nth Lucas number for coefficients p and q.

    A Lucas number is a generalization of the Fibonacci
    Sequence.  The nth Lucas number L(n) is given by the
    recursive definition

        L(0) = 0
        L(1) = 1
        L(n) = p*L(n-1) - q*L(n-2)

    Parameter n: The position in the Lucas sequence
    Precondition: n is an int >= 0

    Parameter p: The p coefficient
    Parameter p is an int

    Parameter q: The q coefficient
    Parameter q is an int
    """
    # Do not use loops or ** anywhere in your code.
    pass # Implement me
