"""
A completed test script for the recursive functions.

Author: Walker M. White
Date: July 30, 2019
"""
import recurse
import divide
import introcs


def test_lucas():
    """
    Test procedure for the function lucas()
    """
    print('Testing lucas()')

    result = recurse.lucas(0,1,-1)
    introcs.assert_equals(0,result)

    result = recurse.lucas(1,1,-1)
    introcs.assert_equals(1,result)

    result = recurse.lucas(2,1,-1)
    introcs.assert_equals(1,result)

    result = recurse.lucas(6,1,-1)
    introcs.assert_equals(8,result)

    result = recurse.lucas(6,2,-1)
    introcs.assert_equals(70,result)

    result = recurse.lucas(6,1,1)
    introcs.assert_equals(0,result)

    result = recurse.lucas(6,1,2)
    introcs.assert_equals(5,result)


def test_prod():
    """
    Test procedure for the function prod()
    """
    print('Testing prod()')

    result = divide.prod(())
    introcs.assert_equals(1,result)

    result = divide.prod((5,))
    introcs.assert_equals(5,result)

    result = divide.prod((1,2,3,1))
    introcs.assert_equals(6,result)

    result = divide.prod((7,12,1,2,2))
    introcs.assert_equals(336,result)

    result = divide.prod((7,12,0,2,2))
    introcs.assert_equals(0,result)

    result = divide.prod((1,1,1,1))
    introcs.assert_equals(1,result)


def test_depunct():
    """
    Test the function depunct
    """
    print('Testing depunct()')

    result = divide.depunct('')
    introcs.assert_equals('', result)

    result = divide.depunct('(')
    introcs.assert_equals('', result)

    result = divide.depunct(' ')
    introcs.assert_equals('', result)

    result = divide.depunct('a')
    introcs.assert_equals('a', result)

    result = divide.depunct('(@$*&@')
    introcs.assert_equals('', result)

    result = divide.depunct('Hello')
    introcs.assert_equals('Hello', result)

    result =  divide.depunct('  f,o**o!!!')
    introcs.assert_equals('foo', result)

    result = divide.depunct('f  (!*@&,.<>:\'  oo')
    introcs.assert_equals('foo', result)


def test_reverse():
    """
    Test the function reverse
    """
    print('Testing reverse()')

    result = divide.reverse('')
    introcs.assert_equals('', result)

    result = divide.reverse('a')
    introcs.assert_equals('a', result)

    result = divide.reverse('reverse')
    introcs.assert_equals('esrever', result)

    result = divide.reverse('amanaplanacanalpanama')
    introcs.assert_equals('amanaplanacanalpanama', result)

    result = divide.reverse('amanap lanac a nalp a nam a')
    introcs.assert_equals('a man a plan a canal panama', result)


if __name__ == '__main__':
    test_lucas()
    test_prod()
    test_depunct()
    test_reverse()
    print('The recursive functions passed all tests.')
